//////////////////////////////////////////////////////////////////////////////
//   ///////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "_MATH_Noise.h"
#include "_DRAW_2D.h"

//////////////////////////////////////////////////////////////////////////////
int keyExit = 0, preset = 1, HelpTimer = 0, whorses = 1;
tfloat offs = 347.347, offs_san, size_san, dir = -1, force = 1.5; 
dwRGB c1, c2, cf = 0xffffffff;
Noise2D ns;

//////////////////////////////////////////////////////
tfloat nm[2000];

void waves(tfloat lev0, tfloat lev, tfloat sw, tfloat sc, tfloat ofs, tfloat ofs_x, dwRGB c, dwRGB cw)
{
  int ex = no, xi = 0;
  tfloat z, e, n, x = 0, y, xs = 2500 - 2000 * sw + ofs_x, xe = 2500 + 2000 * sw + ofs_x, d = xe - xs;
  DrawPolyNew(); DrawPolyTo(0, DrawYR * (1 - lev0 + 0.05 * force * sc) + 0.5);
  while (!ex)
  { ex = (x > DrawXR);
    z = xs + d * x / DrawXR;
    e = force * 0.05 * sc * (ns.GetNs(z / force, ofs, interpHERMIT, 0.15 * sc * force, interpCAVE) + 0.25 * ns.GetNs(2.5 * z / force, ofs * 1.35 + 1347, interpHERMIT, 0.1 * sc * force, interpCAVE));
    n = lev + e + force * 0.075 * sc * ns.GetNs(z * 0.5 / force, ofs + 2347, interpHERMIT);// + sc * (1 + sin(sw * x * 0.05)) * 0.02;
    DrawPolyTo(x, DrawYL - n * DrawYL);
    nm[xi] = n; xi += 1;    
    x += 3; 
  };
  DrawPolyTo(DrawXR, DrawYR * (1 - lev0 + 0.05 * force * sc) + 0.5); DrawPoly(c);
  
  if (whorses)
  { int i, f = no, ii;
    for (i = 0; i < xi - 1; ++i)
    { tfloat r = max(nm[i] - lev - 0.075 * sc * (force + 0.1), 0); 
      if (r > 0.0001)
      { if (!f) { f = Yes; DrawPolyNew(); ii = i; };
        DrawPolyTo(i * 3, DrawYL - nm[i] * DrawYL - 200 * r);
      } else
      { if (f) { for (int j = i; j >= ii; j--) DrawPolyTo(j * 3, DrawYL - nm[j] * DrawYL); 
                 DrawPoly(cw); f = no;
               };
      };
    }; 
    if (f) { for (int j = i - 1; j >= ii; j--) DrawPolyTo(j * 3, DrawYL - nm[j] * DrawYL); 
             DrawPoly(cw); 
           };
  };  
};/**/

/////////////////////////////////////////////////////////////////////////////////////////
void presetChange()
{
  preset = (preset + 1) % 4;
  switch(preset)
  { case 0: c1 = RGBis(70, 0, 0); c2 = RGBis(255, 70, 0); break;
    case 1: c1 = RGBis(0, 35, 85); c2 = RGBis(0, 175, 255); break;
    case 2: c1 = RGBis(70, 0, 35); c2 = RGBis(255, 135, 0); break;
    case 3: c1 = RGBis(0, 50, 25); c2 = RGBis(0, 225, 155); break;
  };
};

void keyPressed()                           //  [ ] 
{
  if (II.KeyUp[_Space_]) whorses = 1 - whorses; 
  if (II.KeyUp[_CU_]) floatLinc(force, 3, 0.25); 
  if (II.KeyUp[_CD_]) floatLdec(force, 1, 0.25);
  if (II.KeyUp[_Enter_]) presetChange();
  if (II.KeyUp[_CL_]) dir = 1;
  if (II.KeyUp[_CR_]) dir = -1;
  if (II.KeyUp[_F1_]) if (HelpTimer) HelpTimer = 0; else HelpTimer = 25 * 10;
  keyExit = (II.KeyUp[_Esc_]);
  II.Reset();
};

//////////////////////////////////////////////////////////////////////////////
TextSPR *info;

/////////////////////////////////////////////////////////////////////////////////////////////////
void CommonsInit()
{ 
  FC_FpsSet(AUTO);             //    
  FC_DrawPaint = Yes;          //  fps   DrawPaint();
  RandomSeed();
  Draw2D_Init(); ForceActivate(); ScreenLoadWait();
  info = new TextSPR(L"TYPE_EN_RU"); info->LineSpace = 4;
  OnKeyUpDo(keyPressed);       //     
  presetChange();

  offs_san = DrawXR * 0.75; size_san = DrawYR / 2;
  
  ns.Make(50, 50, 100);
  II.Reset();
};


//////////////////////////////////////////////////////////////////////////////////////////////////
void CommonsDone()
{
  delete info;
  Draw2D_Done();
};

//////////////////////////////////////////////////////////////////////////////////////////////////
int infoDrawed = no;
void DrawInfo()
{
  if (!HelpTimer) return;
  HelpTimer--;
  infoDrawed = Yes;
  tRegion r = RegionCenterIs(230, 172);
  DrawRegionStore.Save(r);
  tfRegion fr = RegionTofRegion(r);
  fDrawRoundRect(fr, 20, RGBis(50, 50, 50), modeMUL); 
  info->Place(0, 0, modeADD + fromCC, "Conrol Keys:\n\nEnter - Color\nCursor Left, Right - Direction\nCursor Up, Down - Waves Force\nSpace - Off/On White Horses\n.........................................................................................\nF1 - hide/show Help\nEsc - Exit");
  info->Draw();
};

//////////////////////////////////////////////////////////////////////////////////////////////////
void RestoreInfo()
{
  if (!infoDrawed) return;
  DrawRegionStore.Restore();
  infoDrawed = no;
};

//////////////////////////////////////////////////////////////////////////////////////////////////
int levels = 19; // 0..8 = 9

void Ocean()
{
  offs += 1.25 * dir; if (fabs(offs) > 347000000) offs = 347.347;
  offs_san += 0.333 * dir; if (offs_san < -size_san) offs_san = DrawXR + size_san;
  for (int i = 0; i <= levels; i++)
  { tfloat k = (tfloat)i / levels, lev0;
    if (i == levels) lev0 = 0; else lev0 = 0.4 - Lower((tfloat)(i + 1) / levels, 0.70) * 0.3;
    waves(lev0, 0.4 - Lower(k, 0.70) * 0.3, 1.7 - 1.5 * Power(k, 0.5), 0.1 + 0.8 * Lower(k, 0.5), offs * 1.5 + k * 700, -offs, RGBblend(c2, c1, 15 + k * 240), RGBblend(c2, cf, 15 + k * 240));
  };
};

void DrawAll()
{
  DrawFill(RGBblend(c1, c2, 235));
  fDrawCircle(offs_san, DrawYR * 0.6, size_san, RGBblend(c1, c2, 255));

  Ocean();
  
  DrawInfo(); 
  DrawPaint();
  RestoreInfo();
};

//////////////////////////////////////////////////////////////////////////////
//   //////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
void Main()
{
  CommonsInit();                  //   ;  
  
  while (!keyExit) DrawAll();   

  CommonsDone();                  //   ;
};
//////////////////////////////////////////////////////////////////////////////
int LetProcess()
{
  //MouseShowCursor = no;
  WinName = L"CG : Ocean";   //    
  VS_CColor = RGBis(0, 0, 0);   //   
  DrawSet(FullScreen);          //   ( )  , FullScreen   
  ProcessFunc = Main;            //    -  
  return on;
};
int Init_LetProcess = LetProcess();

